*! 1.0.1 NJC 3 July 2012
*! 1.0.0 NJC 21 March 2012
program qenvnormal, sort  
	version 9
	syntax varname(numeric) [if] [in], GENerate(str) [ reps(int 100) Level(real 95) ]

	marksample touse
	qui count if `touse'
	if r(N) == 0 error 2000

	if `level' <= 0 { 
		di as err "level() must be positive" 
		exit 198 
	} 
	else if `level' > 100 { 
		di as err "level() must not exceed 100" 
		exit 198 
	} 

	tokenize "`generate'"
	args lower upper garbage 
	if "`upper'" == "" | "`garbage'" != "" {
        	di as err "two names required in generate()"
	        exit 198
	}

	confirm new var `generate'

	sort `touse' `varlist' 
	mata : _normalqenv("`varlist'", "`touse'", "`generate'", `reps', `level')

	quietly { 
		count if `lower' > `lower'[_n+1] & `touse' 
		if r(N) > 0 { 
			noi di "warning: `lower' not weakly monotone increasing" 
		} 
		count if `upper' > `upper'[_n+1] & `touse' 
		if r(N) > 0 { 
			noi di "warning: `upper' not weakly monotone increasing" 
		} 
	} 
end

mata:

void _normalqenv(
       string scalar varname,
       string scalar tousename,
       string rowvector newnames,
       real scalar reps,
       real scalar level)
{

real matrix compare
real colvector y
real scalar mean, sd, n, L, l1, l2, U, u1, u2

st_view(y = ., ., varname, tousename)
mean = mean(y); sd = sqrt(variance(y)); n = rows(y)

compare = J(n, 0, .)

for (j = 1; j <= reps; j++) {
       compare = compare, sort(rnormal(n, 1, mean, sd), 1)
}

L = reps * (100 - level)/200
l1 = ceil(L)
l2 = l1 + (L == l1) 
if (l1 == 0) l1 = 1 
U = reps * (100 + level)/200
u1 = ceil(U)
u2 = u1 + (U == u1)
if (u2 == n + 1) u2 = n

envelope = J(n, 2, .)
for (i = 1; i <= n; i++) {
       x = sort(compare[i,]', 1)
       envelope[i,] = ((x[l1] + x[l2])/2, (x[u1] + x[u2])/2)
}

newnames = tokens(newnames)
(void) st_addvar("float", newnames)
st_store(., newnames, tousename, envelope)

}

end


