
set scheme s1color

clear 

u uscity

/// not used in talk 
graph hbar (asis) pop2 if strpos(name2, "TX") & code == . & pop > 100000, over(name1, sort(pop2) descending) ///
title(25 largest cities in Texas) yla(0(1000)6000, format(%2.0f)) ysc(titlegap(*4))  

more 

graph hbar (asis) pop2 if strpos(name2, "CA") & code == . & pop > 140000, over(name1, sort(pop2) descending) ///
title(25 largest cities in California) yla(0(2500)12500, format(%2.0f)) ysc(titlegap(*4)) name(california1, replace) 

more 

/// not used in talk 
graph dot (asis) pop2 if strpos(name2, "TX") & code == . & pop > 100000, over(name1, sort(pop2) descending) ysc(log titlegap(*4)) exclude0 linetype(line) ///
yla(100 200 500  1000  2000 5000, format(%2.0f)) lines(lw(vthin) lc(gs14)) marker(1, ms(Sh)) title(25 largest cities in Texas)

more 

graph dot (asis) pop2 if strpos(name2, "CA") & code == . & pop > 140000, over(name1, sort(pop2) descending) ysc(log titlegap(*4)) exclude0 linetype(line) ///
yla(200 500 1000  2000 5000 10000, format(%2.0f)) lines(lw(vthin) lc(gs14)) marker(1, ms(Sh)) title(25 largest cities in California) ysc(r(140 .)) name(california2, replace) 

more 

gen logpop = log10(pop)

histogram logpop if code == . , start(4) width(0.2) frequency yla(, ang(h))  xla(4 "10000" 5 "100000" 6 "1 m" 7 "10 m") ///
xtitle("`: var label pop'") xsc(titlegap(*4)) subtitle("Core based statistical areas, USA", place(w)) name(histo1, replace) 

more 

twoway histogram logpop if code == . ,  frequency start(4) width(0.2) bfcolor(red*0.4) blcolor(gs14) || ///
histogram logpop if code == . & type == 0 , frequency start(4) width(0.2) bfcolor(blue*0.4) blcolor(gs14)  ///
xtitle("`: var label pop'") xsc(titlegap(*4)) subtitle("Core based statistical areas, USA", place(w)) /// 
xla(4 "10000" 5 "100000" 6 "1 m" 7 "10 m") ///
legend(order(2 "Micropolitan" 1 "Metropolitan") ring(0) col(1) pos(1)) yla(, ang(h)) name(histo2, replace) 

more 

use cumbrian_cirques, clear

kdensity length, title("") name(d1, replace) 

tkdensity length, biweight bw(0.4) graphopts(name(d2, replace)) 

kdensity width, title("") name(d3, replace)

tkdensity width, biweight bw(0.4) graphopts(name(d4, replace)) 

graph combine d1 d2 d3 d4, name(d, replace) 

more 

stripplot length width, stack width(50) box(barw(0.1)) pctile(5) boffset(-0.1) xtitle(size (m)) caption(boxes show 5 25 50 75 95 percentiles) ///
yla(, noticks) subtitle(50 m bins, place(w)) name(strip1, replace) 

more 

sysuse census, clear 

local abbrev ///
AL AK AZ AR CA CO CT DE FL GA ///
HI ID IL IN IA KS KY LA ME MD ///
MA MI MN MS MO MT NE NV NH NJ ///
NM NY NC ND OH OK OR PA RI SC ///
SD TN TX UT VT VA WA WV WI WY

gen abbrev = "" 

tokenize "`abbrev'" 

qui forval i = 1/50 { 
	replace abbrev = "``i''" in `i' 
}

stripplot medage, stack ms(Sh) msize(*3.5) width(0.5) ///
mla(abbrev) mlabpos(0) mlabsize(*.9) ysc(off) plotregion(lstyle(none)) xtitle(Median age 1980) subtitle(0.5 year bins, place(w)) name(strip2, replace) 

more 

u smoking_oecd, clear 

stripplot percent, over(period) by(gender, subtitle("Regular cigarette smoking in 15 year olds")  note("USA highlighted") legend(off)) ///
vertical stack height(0.3) separate(is) xti("") ms(oh O) mcolor(gs8 blue) msize(*1 *1.2) yti(percent) yla(, ang(h)) name(smoking1, replace) 

more 

devnplot percent gender period, xla(, labsize(*.8) axis(2)) recast(line) xti("", axis(2)) xti("", axis(1)) yla(, ang(h)) superplines(lc(gs14)) name(smoking2, replace) 

more

egen nation = group(country) 

devnplot percent gender period, xla(, labsize(*.8) axis(2)) recast(line) xti("", axis(2)) xti("", axis(1)) yla(, ang(h)) superplines(lc(gs14)) ///
separate(nation == 24) separateopts(mcolor(blue ..) msize(*1.2 ..)) note("USA highlighted") name(smoking3, replace) 

more 

su nation, meanonly 

forval i = 1/`r(max)' {
	local call `call'  || line percent period if nation == `i'
}

twoway `call', by(gender, note("") legend(off)) yla(, ang(h)) xla(, val) xsc(r(0.84 4.16)) xti("") name(smoking0, replace) 

more 

hdquantile percent, by(gender period) gen(hd_percent)

qplot percent, over(period) by(gender, note("")) legend(row(1)) ///
ytitle("`: var label percent'") yla(, ang(h)) recast(connected) name(smoking4, replace) 

more 

qplot hd_percent, over(period) by(gender, note("")) legend(row(1)) ///
ytitle("`: var label percent'") yla(, ang(h)) recast(connected) name(smoking5, replace) 

more 

gen diff = hd_percent - percent

scatter diff percent, ytitle("smoothed quantile - observed quantile, %") ms(oh) ///
yli(0, lc(gs14)) yla(, ang(h)) name(smoking6, replace) 

more 

use rayleigh, clear 

devnplot mass method detail, superplines

/// Graph Editor used 
graph use rayleigh 

more 

sysuse auto, clear 

multqplot price-foreign, combine(name(mqplot, replace)) 

more  

qenvnormal weight, gen(lower upper)

qplot weight lower upper, ms(oh none ..) c(. l l) lc(gs10 ..) legend(off) ytitle("Weight, lb") yla(, ang(h)) name(env1, replace) subtitle(95% reference intervals, place(w)) 

more 

su weight

qplot weight lower upper, ms(oh none ..) c(. l l) lc(gs10 ..) legend(off) ytitle("Weight, lb") ///
trscale(`r(mean)' + `r(sd)' * invnormal(@)) xtitle(Normal quantiles) yla(1000(1000)5000, ang(h)) name(env2, replace) subtitle(95% reference intervals, place(w))  


